#ifdef USAVE

#include "USApi.h"
#include "USApi_idd.h"
#include "USApiDefs.h"

#include "USave.h"
#include "DoomDef.h"

#define sz_VERSION "0.8"
#define YEAR		1999
#define MONTH		3
#define DAY			9

typedef struct
{
	char    *name;
	int     *location;
	int     defaultvalue;
	int     scantranslate;      // PC scan code hack
	int     untranslated;       // lousy hack
} default_t;

extern  int     key_right, key_left, key_up, key_down;
extern  int     key_strafeleft, key_straferight;
extern  int     key_fire, key_use, key_strafe, key_speed;
extern	int		key_flyup, key_flydown, key_flycenter;
extern	int		key_lookup, key_lookdown, key_lookcenter;
extern	int		key_invleft, key_invright, key_useartifact;

extern  int         mousebfire;
extern  int         mousebstrafe;
extern  int         mousebforward;

extern  int         joybfire;
extern  int         joybstrafe;
extern  int         joybuse;
extern  int         joybspeed;
extern  int screenblocks;
extern int snd_Channels,snd_MaxVolume,snd_MusicVolume;
extern int mouseSensitivity;
extern int     usemouse;
extern int     usejoystick,usegamma;

extern char *chat_macros[10];

default_t defaults[] =
{
	{ "mouse_sensitivity", &mouseSensitivity, 5 },

#ifndef __NeXT__
	{ "sfx_volume", &snd_MaxVolume, 10},
	{ "music_volume", &snd_MusicVolume, 10},
#endif

//#ifdef __NeXT__	// MR
	{ "key_right", &key_right, KEY_RIGHTARROW },
	{ "key_left", &key_left, KEY_LEFTARROW },
	{ "key_up", &key_up, KEY_UPARROW },
	{ "key_down", &key_down, KEY_DOWNARROW },
	{ "key_strafeleft", &key_strafeleft, ',' },
	{ "key_straferight", &key_straferight, '.' },
	{ "key_flyup", &key_flyup, 'u' },
	{ "key_flydown", &key_flydown, 'j' },
	{ "key_flycenter", &key_flycenter, 'k' },
	{ "key_lookup", &key_lookup, 'm' },
	{ "key_lookdown", &key_lookdown, 'b' },
	{ "key_lookcenter", &key_lookcenter, 'n' },
	{ "key_invleft", &key_invleft, '[' },
	{ "key_invright", &key_invright, ']' },
	{ "key_useartifact", &key_useartifact, 13 },

	{ "key_fire", &key_fire, ' ', 1 },
	{ "key_use", &key_use, 'x', 1 },
	{ "key_strafe", &key_strafe, 'c', 1 },
	{ "key_speed", &key_speed, 'z', 1 },
//#endif	// MR

	{ "use_mouse", &usemouse, 1 },
	{ "mouseb_fire", &mousebfire, 0 },
	{ "mouseb_strafe", &mousebstrafe, 1 },
	{ "mouseb_forward", &mousebforward, 2 },

	{ "use_joystick", &usejoystick, 0 },
	{ "joyb_fire", &joybfire, 0 },
	{ "joyb_strafe", &joybstrafe, 1 },
	{ "joyb_use", &joybuse, 3 },
	{ "joyb_speed", &joybspeed, 2 },

	{ "screenblocks", &screenblocks, 10 },

#ifndef __NeXT__
	{ "snd_channels", &snd_Channels, 3 },
// MR
/*	{ "snd_musicdevice", &snd_DesiredMusicDevice, 0 },
	{ "snd_sfxdevice", &snd_DesiredSfxDevice, 0 },
	{ "snd_sbport", &snd_SBport, 544 },
	{ "snd_sbirq", &snd_SBirq, -1 },
	{ "snd_sbdma", &snd_SBdma, -1 },
	{ "snd_mport", &snd_Mport, -1 },*/
#endif

	{ "usegamma", &usegamma, 0 },

	{ "chatmacro0", (int *) &chat_macros[0], (int) HUSTR_CHATMACRO0 },
	{ "chatmacro1", (int *) &chat_macros[1], (int) HUSTR_CHATMACRO1 },
	{ "chatmacro2", (int *) &chat_macros[2], (int) HUSTR_CHATMACRO2 },
	{ "chatmacro3", (int *) &chat_macros[3], (int) HUSTR_CHATMACRO3 },
	{ "chatmacro4", (int *) &chat_macros[4], (int) HUSTR_CHATMACRO4 },
	{ "chatmacro5", (int *) &chat_macros[5], (int) HUSTR_CHATMACRO5 },
	{ "chatmacro6", (int *) &chat_macros[6], (int) HUSTR_CHATMACRO6 },
	{ "chatmacro7", (int *) &chat_macros[7], (int) HUSTR_CHATMACRO7 },
	{ "chatmacro8", (int *) &chat_macros[8], (int) HUSTR_CHATMACRO8 },
	{ "chatmacro9", (int *) &chat_macros[9], (int) HUSTR_CHATMACRO9 }
};

int numdefaults;
char *defaultfile;

typedef int bool;
#define true 1
#define false 0

long m_lSessionCode,m_lEventCode;

void fn_szGetExeName(char *szFullExeName,char *szExeName)
{ char *ptr;
	
	ptr=szFullExeName+strlen(szFullExeName);
	while (*--ptr!='\\');
	strcpy(szExeName,ptr+1);
	*ptr=0;
}

bool US_RegisterGame(IUniversalSave *pIUS,char *szPathName,char *szExeName)
{
IGame *pIGame;
IGameQuery *pIQuery;
HRESULT hResult;

	IUniversalSave_QueryInterface(pIUS,&iidIGameQuery,(void **)&pIQuery);
	//
	// See if it already exists
	hResult=IGameQuery_USQueryGUID(pIQuery,(unsigned char *)GUID_GAME,&pIGame);
	IGameQuery_Release(pIQuery);
	if (hResult == USLAST)
		{
		IGame_Release(pIGame);
		return true;
		}

	//
	// Create the game handle
	hResult=IUniversalSave_QueryInterface(pIUS,&iidIGame,(void **)&pIGame);
	if (FAILED(hResult))
		{
		return false;
		}

	IGame_USSetGUID(pIGame,(unsigned char *)GUID_GAME);
	IGame_USSetName(pIGame,(unsigned char *)"WinHeretic");
	IGame_USSetDeveloper(pIGame,(unsigned char *)"Kokak");
	IGame_USSetPathname(pIGame,(unsigned char *)szPathName);
	IGame_USSetFilename(pIGame,(unsigned char *)szExeName);

	//
	// Register the game
	if (FAILED(IGame_USCommit(pIGame)))
		{
		return false;
		}
	IGame_Release(pIGame);

return true;
}

bool US_RegisterGameVer(IUniversalSave *pIUS)
{
IGameVerQuery *pIQuery;
IGameVersion *pIVersion;
US_DATETIME dtRelease;
HRESULT hResult;

	//
	// See if it already exists
	IUniversalSave_QueryInterface(pIUS,&iidIGameVerQuery,(void **)&pIQuery);
	hResult=IGameVerQuery_USQueryGUID(pIQuery,(unsigned char *)GUID_GAMEVER,&pIVersion);
	IGameVerQuery_Release(pIQuery);
	if (hResult == USLAST)
		{
		IGameVersion_Release(pIVersion);
		return true;
		}

	//
	// Create a version handle
	IUniversalSave_QueryInterface(pIUS,&iidIGameVersion,(void **)&pIVersion);

	//
	// Set the version parameters
	IGameVersion_USSetGameGUID(pIVersion,(unsigned char *)GUID_GAME);
	IGameVersion_USSetGUID(pIVersion,(unsigned char *)GUID_GAMEVER);
	IGameVersion_USSetName(pIVersion,(unsigned char *)sz_VERSION);
	dtRelease.m_nYear=1999;
	dtRelease.m_nMonth=3;
	dtRelease.m_nDay=9;
	IGameVersion_USSetRelease(pIVersion,&dtRelease);

	//
	// Register the game version
	if (FAILED(IGameVersion_USCommit(pIVersion)))
		{
		return false;
		}
	IGameVersion_Release(pIVersion);

return true;
}

bool US_RegisterSaveVer(IUniversalSave *pIUS)
{
ISaveVerQuery *pIQuery;
ISaveVersion *pIVersion;
HRESULT hResult;

	//
	// See if it already exists
	IUniversalSave_QueryInterface(pIUS,&iidISaveVerQuery,(void **)&pIQuery);
	hResult=ISaveVerQuery_USQueryGUID(pIQuery,(unsigned char *)GUID_SAVEVER,&pIVersion);
	ISaveVerQuery_Release(pIQuery);
	if (hResult == USLAST)
		{
		ISaveVersion_Release(pIVersion);
		return true;
		}

	//
	// Create a version handle
	IUniversalSave_QueryInterface(pIUS,&iidISaveVersion,(void **)&pIVersion);

	//
	// Set the version parameters
	ISaveVersion_USSetGameGUID(pIVersion,(unsigned char *)GUID_GAME);
	ISaveVersion_USSetGUID(pIVersion,(unsigned char *)GUID_SAVEVER);
	ISaveVersion_USSetName(pIVersion,(unsigned char *)sz_VERSION);

	//
	// Register the save version
	if (FAILED(ISaveVersion_USCommit(pIVersion)))
		{
		return false;
		}
	ISaveVersion_Release(pIVersion);

return true;
}

bool US_RegisterStatVer(IUniversalSave *pIUS)
{
IStatVerQuery *pIQuery;
IStatVersion *pIVersion;
HRESULT hResult;

	//
	// See if it already exists
	IUniversalSave_QueryInterface(pIUS,&iidIStatVerQuery,(void **)&pIQuery);
	hResult=IStatVerQuery_USQueryGUID(pIQuery,(unsigned char *)GUID_STATVER,&pIVersion);
	IStatVerQuery_Release(pIQuery);
	if (hResult == USLAST)
		{
		IStatVersion_Release(pIVersion);
		return true;
		}

	//
	// Create a version handle
	IUniversalSave_QueryInterface(pIUS,&iidIStatVersion,(void **)&pIVersion);

	//
	// Set the version parameters
	IStatVersion_USSetGameGUID(pIVersion,(unsigned char *)GUID_GAME);
	IStatVersion_USSetGUID(pIVersion,(unsigned char *)GUID_STATVER);
	IStatVersion_USSetName(pIVersion,(unsigned char *)sz_VERSION);

	//
	// Register the statistics version
	if (FAILED(IStatVersion_USCommit(pIVersion)))
		{
		return false;
		}
	IStatVersion_Release(pIVersion);

return true;
}

bool US_AppRegister(char *szFullExeName)
{
CLSID clsidUS;
IUniversalSave *pIUS;
char szExeName[255];

	fn_szGetExeName(szFullExeName,szExeName);
	
	//
	// Make sure COM is initialized
	CoInitialize(NULL);

	CLSIDFromProgID(L"UniversalSave.UniversalSave.1",&clsidUS);
	CoCreateInstance(
		&clsidUS,
		NULL,
		CLSCTX_INPROC_SERVER,
		&iidIUniversalSave,
		(void **)&pIUS);

	if (!US_RegisterGame(pIUS,szFullExeName,szExeName))
		{
		IUniversalSave_Release(pIUS);
		return false;
		}
	if (!US_RegisterGameVer(pIUS))
		{
		IUniversalSave_Release(pIUS);
		return false;
		}
	if (!US_RegisterSaveVer(pIUS))
		{
		IUniversalSave_Release(pIUS);
		return false;
		}
	if (!US_RegisterStatVer(pIUS))
		{
		IUniversalSave_Release(pIUS);
		return false;
		}

	//
	// Release the interfaces
	IUniversalSave_Release(pIUS);

return true;
}

void US_InitGameSession(void)
{
CLSID clsidUS;
IUniversalSave *pIUS;
IGameSession *pISession;

	m_lSessionCode=-1;
	m_lEventCode=-1;

	//
	// Create the interfaces
	CLSIDFromProgID(L"UniversalSave.UniversalSave.1",&clsidUS);
	CoCreateInstance(
		&clsidUS,
		NULL,
		CLSCTX_INPROC_SERVER,
		&iidIUniversalSave,
		(void **)&pIUS);

	//
	// Create the game session
	IUniversalSave_QueryInterface(pIUS,&iidIGameSession,(void **)&pISession);

	IGameSession_USSetGameGUID(pISession,(unsigned char *)GUID_GAME);
	IGameSession_USSetStatVerGUID(pISession,(unsigned char *)GUID_STATVER);

	IGameSession_USCommit(pISession);

	//
	// Get the session code
	IGameSession_USGetCode(pISession,&m_lSessionCode);

	IGameSession_Release(pISession);

	//
	// Release the interfaces
	IUniversalSave_Release(pIUS);
}

void US_TermGameSession(void)
{
CLSID clsidUS;
IUniversalSave *pIUS;
IGameSession *pISession;
IGameSessionQuery *pIQuery;
HRESULT hResult;

	//
	// Create the interfaces
	CLSIDFromProgID(L"UniversalSave.UniversalSave.1",&clsidUS);
	CoCreateInstance(
		&clsidUS,
		NULL,
		CLSCTX_INPROC_SERVER,
		&iidIUniversalSave,
		(void **)&pIUS);

	//
	// Query for the game session
	IUniversalSave_QueryInterface(pIUS,&iidIGameSessionQuery,(void **)&pIQuery);

	hResult=IGameSessionQuery_USQueryCode(pIQuery,m_lSessionCode,&pISession);
	IGameSessionQuery_Release(pIQuery);
	if (hResult == USEMPTY)
		{
		IUniversalSave_Release(pIUS);
		return;
		}

	IGameSession_USCommit(pISession);

	//
	// Release the interfaces
	IGameSession_Release(pISession);
	IUniversalSave_Release(pIUS);
}

void US_M_SaveDefaults(void)
{
CLSID clsidUS;
IUniversalSave *pIUS;
IGameQuery *pIGMQuery;
IPlayerQuery *pIPLQuery;
IGame *pIGame;
IPlayer *pIPlayer;
IGameStorage *pIStorage;
IGameStream *pIStream;
unsigned long ulWritten;

	//
	// Create the interfaces
	CLSIDFromProgID(L"UniversalSave.UniversalSave.1",&clsidUS);
	CoCreateInstance(
		&clsidUS,
		NULL,
		CLSCTX_INPROC_SERVER,
		&iidIUniversalSave,
		(void **)&pIUS);
	IUniversalSave_QueryInterface(pIUS,&iidIGameQuery,(void **)&pIGMQuery);
	IUniversalSave_QueryInterface(pIUS,&iidIPlayerQuery,(void **)&pIPLQuery);

	//
	// Get a handle to the game
	IGameQuery_USQueryGUID(pIGMQuery,(unsigned char *)GUID_GAME,&pIGame);
	IGameQuery_Release(pIGMQuery);
	//
	// Get a handle to the "generic" player
	IPlayerQuery_USQueryGUID(pIPLQuery,(unsigned char *)GUID_GENERIC_PLAYER,&pIPlayer);
	IPlayerQuery_Release(pIPLQuery);
	//
	// Attach to the storage - This storage is automatically created by the USave framework
	// when the game is registered.
	IPlayer_USAttachSettings(pIPlayer,pIGame,&pIStorage);

	//
	// Create a set of organized files to store the settings
	IGameStorage_USCreateStream(pIStorage,(unsigned char *)"Keyboard");
	IGameStorage_USCreateStream(pIStorage,(unsigned char *)"Mouse");
	IGameStorage_USCreateStream(pIStorage,(unsigned char *)"Sound");
	IGameStorage_USCreateStream(pIStorage,(unsigned char *)"Misc");

	//
	// Save the keyboard settings
	IGameStorage_USOpenStream(pIStorage,(unsigned char *)"Keyboard",USMODE_CREATE,&pIStream);

	IGameStream_USWrite(pIStream,
		(unsigned char *)&key_right,sizeof(key_right),&ulWritten);
	IGameStream_USWrite(pIStream,
		(unsigned char *)&key_left,sizeof(key_left),&ulWritten);
	IGameStream_USWrite(pIStream,
		(unsigned char *)&key_up,sizeof(key_up),&ulWritten);
	IGameStream_USWrite(pIStream,
		(unsigned char *)&key_down,sizeof(key_down),&ulWritten);
	IGameStream_USWrite(pIStream,
		(unsigned char *)&key_strafeleft,sizeof(key_strafeleft),&ulWritten);
	IGameStream_USWrite(pIStream,
		(unsigned char *)&key_straferight,sizeof(key_straferight),&ulWritten);
	IGameStream_USWrite(pIStream,
		(unsigned char *)&key_fire,sizeof(key_fire),&ulWritten);
	IGameStream_USWrite(pIStream,
		(unsigned char *)&key_use,sizeof(key_use),&ulWritten);
	IGameStream_USWrite(pIStream,
		(unsigned char *)&key_strafe,sizeof(key_strafe),&ulWritten);
	IGameStream_USWrite(pIStream,
		(unsigned char *)&key_speed,sizeof(key_speed),&ulWritten);
	IGameStream_USWrite(pIStream,
		(unsigned char *)&key_flyup,sizeof(key_flyup),&ulWritten);
	IGameStream_USWrite(pIStream,
		(unsigned char *)&key_flydown,sizeof(key_flydown),&ulWritten);
	IGameStream_USWrite(pIStream,
		(unsigned char *)&key_flycenter,sizeof(key_flycenter),&ulWritten);
	IGameStream_USWrite(pIStream,
		(unsigned char *)&key_lookup,sizeof(key_lookup),&ulWritten);
	IGameStream_USWrite(pIStream,
		(unsigned char *)&key_lookdown,sizeof(key_lookdown),&ulWritten);
	IGameStream_USWrite(pIStream,
		(unsigned char *)&key_lookcenter,sizeof(key_lookcenter),&ulWritten);
	IGameStream_USWrite(pIStream,
		(unsigned char *)&key_invleft,sizeof(key_invleft),&ulWritten);
	IGameStream_USWrite(pIStream,
		(unsigned char *)&key_invright,sizeof(key_invright),&ulWritten);
	IGameStream_USWrite(pIStream,
		(unsigned char *)&key_useartifact,sizeof(key_useartifact),&ulWritten);

	IGameStream_Release(pIStream);

	//
	// Save the mouse settings
	IGameStorage_USOpenStream(pIStorage,
		(unsigned char *)"Mouse",USMODE_CREATE,&pIStream);

	IGameStream_USWrite(pIStream,
		(unsigned char *)&mouseSensitivity,sizeof(mouseSensitivity),&ulWritten);
	IGameStream_USWrite(pIStream,
		(unsigned char *)&usemouse,sizeof(usemouse),&ulWritten);
	IGameStream_USWrite(pIStream,
		(unsigned char *)&mousebfire,sizeof(mousebfire),&ulWritten);
	IGameStream_USWrite(pIStream,
		(unsigned char *)&mousebstrafe,sizeof(mousebstrafe),&ulWritten);
	IGameStream_USWrite(pIStream,
		(unsigned char *)&mousebforward,sizeof(mousebforward),&ulWritten);

	IGameStream_Release(pIStream);

	//
	// Save the sound settings
	IGameStorage_USOpenStream(pIStorage,
		(unsigned char *)"Sound",USMODE_CREATE,&pIStream);

	IGameStream_USWrite(pIStream,
		(unsigned char *)&snd_MaxVolume,sizeof(int),&ulWritten);
	IGameStream_USWrite(pIStream,
		(unsigned char *)&snd_MusicVolume,sizeof(int),&ulWritten);
	IGameStream_USWrite(pIStream,
		(unsigned char *)&snd_Channels,sizeof(int),&ulWritten);

	IGameStream_Release(pIStream);

	//
	// Save the misc settings
	IGameStorage_USOpenStream(pIStorage,
		(unsigned char *)"Misc",USMODE_CREATE,&pIStream);

	IGameStream_USWrite(pIStream,
		(unsigned char *)&usejoystick,sizeof(usejoystick),&ulWritten);
	IGameStream_USWrite(pIStream,
		(unsigned char *)&joybfire,sizeof(joybfire),&ulWritten);
	IGameStream_USWrite(pIStream,
		(unsigned char *)&joybstrafe,sizeof(joybstrafe),&ulWritten);
	IGameStream_USWrite(pIStream,
		(unsigned char *)&joybuse,sizeof(joybuse),&ulWritten);
	IGameStream_USWrite(pIStream,
		(unsigned char *)&joybspeed,sizeof(joybspeed),&ulWritten);
	IGameStream_USWrite(pIStream,
		(unsigned char *)&screenblocks,sizeof(screenblocks),&ulWritten);
	IGameStream_USWrite(pIStream,
		(unsigned char *)&usegamma,sizeof(usegamma),&ulWritten);

	IGameStream_Release(pIStream);

	//
	// Detach and close down the storage
	IGameStorage_Release(pIStorage);
	IGame_Release(pIGame);
	IPlayer_Release(pIPlayer);
	IUniversalSave_Release(pIUS);
}

void US_M_LoadDefaults(void)
{
CLSID clsidUS;
IUniversalSave *pIUS;
IGameQuery *pIGMQuery;
IPlayerQuery *pIPLQuery;
IGame *pIGame;
IPlayer *pIPlayer;
IGameStorage *pIStorage;
IGameStream *pIStream;
unsigned long ulRead;
HRESULT hResult;
int i;

	 //
	 // Set the defaults
	 numdefaults = sizeof(defaults)/sizeof(defaults[0]);
	 for (i=0 ; i<numdefaults ; i++)
	  *defaults[i].location = defaults[i].defaultvalue;

	 //
	 // Create the interfaces
	 CLSIDFromProgID(L"UniversalSave.UniversalSave.1",&clsidUS);
	 CoCreateInstance(
	  &clsidUS,
	  NULL,
	  CLSCTX_INPROC_SERVER,
	  &iidIUniversalSave,
	  (void **)&pIUS);
	IUniversalSave_QueryInterface(pIUS,&iidIGameQuery,(void **)&pIGMQuery);
	IUniversalSave_QueryInterface(pIUS,&iidIPlayerQuery,(void **)&pIPLQuery);

	//
	// Get a handle to the game
	IGameQuery_USQueryGUID(pIGMQuery,(unsigned char *)GUID_GAME,&pIGame);
	IGameQuery_Release(pIGMQuery);
	//
	// Get a handle to the "generic" player
	IPlayerQuery_USQueryGUID(pIPLQuery,(unsigned char *)GUID_GENERIC_PLAYER,&pIPlayer);
	IPlayerQuery_Release(pIPLQuery);
	//
	// Attach to the storage - This storage is automatically created by the USave framework
	// when the game is registered.
	IPlayer_USAttachSettings(pIPlayer,pIGame,&pIStorage);

	 //
	 // Read the keyboard settings
	 hResult=IGameStorage_USOpenStream(pIStorage,
	  (unsigned char *)"Keyboard",USMODE_READWRITE,&pIStream);

	 if (SUCCEEDED(hResult))
	  {
	  IGameStream_USRead(pIStream,
	   (unsigned char *)&key_right,sizeof(key_right),&ulRead);
	  IGameStream_USRead(pIStream,
	   (unsigned char *)&key_left,sizeof(key_left),&ulRead);
	  IGameStream_USRead(pIStream,
	   (unsigned char *)&key_up,sizeof(key_up),&ulRead);
	  IGameStream_USRead(pIStream,
	   (unsigned char *)&key_down,sizeof(key_down),&ulRead);
	  IGameStream_USRead(pIStream,
	   (unsigned char *)&key_strafeleft,sizeof(key_strafeleft),&ulRead);
	  IGameStream_USRead(pIStream,
	   (unsigned char *)&key_straferight,sizeof(key_straferight),&ulRead);
	  IGameStream_USRead(pIStream,
	   (unsigned char *)&key_fire,sizeof(key_fire),&ulRead);
	  IGameStream_USRead(pIStream,
	   (unsigned char *)&key_use,sizeof(key_use),&ulRead);
	  IGameStream_USRead(pIStream,
	   (unsigned char *)&key_strafe,sizeof(key_strafe),&ulRead);
	  IGameStream_USRead(pIStream,
	   (unsigned char *)&key_speed,sizeof(key_speed),&ulRead);
	  IGameStream_USRead(pIStream,
	   (unsigned char *)&key_flyup,sizeof(key_flyup),&ulRead);
	  IGameStream_USRead(pIStream,
	   (unsigned char *)&key_flydown,sizeof(key_flydown),&ulRead);
	  IGameStream_USRead(pIStream,
	   (unsigned char *)&key_flycenter,sizeof(key_flycenter),&ulRead);
	  IGameStream_USRead(pIStream,
	   (unsigned char *)&key_lookup,sizeof(key_lookup),&ulRead);
	  IGameStream_USRead(pIStream,
	   (unsigned char *)&key_lookdown,sizeof(key_lookdown),&ulRead);
	  IGameStream_USRead(pIStream,
	   (unsigned char *)&key_lookcenter,sizeof(key_lookcenter),&ulRead);
	  IGameStream_USRead(pIStream,
	   (unsigned char *)&key_invleft,sizeof(key_invleft),&ulRead);
	  IGameStream_USRead(pIStream,
	   (unsigned char *)&key_invright,sizeof(key_invright),&ulRead);
	  IGameStream_USRead(pIStream,
	   (unsigned char *)&key_useartifact,sizeof(key_useartifact),&ulRead);

	  IGameStream_Release(pIStream);
	  }

	 //
	 // Read the mouse settings
	 hResult=IGameStorage_USOpenStream(pIStorage,
	  (unsigned char *)"Mouse",USMODE_READWRITE,&pIStream);

	 if (SUCCEEDED(hResult))
	  {
	  IGameStream_USRead(pIStream,
	   (unsigned char *)&mouseSensitivity,sizeof(mouseSensitivity),&ulRead);
	  IGameStream_USRead(pIStream,
	   (unsigned char *)&usemouse,sizeof(usemouse),&ulRead);
	  IGameStream_USRead(pIStream,
	   (unsigned char *)&mousebfire,sizeof(mousebfire),&ulRead);
	  IGameStream_USRead(pIStream,
	   (unsigned char *)&mousebstrafe,sizeof(mousebstrafe),&ulRead);
	  IGameStream_USRead(pIStream,
	   (unsigned char *)&mousebforward,sizeof(mousebforward),&ulRead);

	  IGameStream_Release(pIStream);
	  }

	 //
	 // Read the sound settings
	 hResult=IGameStorage_USOpenStream(pIStorage,
	  (unsigned char *)"Sound",USMODE_READWRITE,&pIStream);

	 if (SUCCEEDED(hResult))
	  {
	  IGameStream_USRead(pIStream,
	   (unsigned char *)&snd_MaxVolume,sizeof(int),&ulRead);
	  IGameStream_USRead(pIStream,
	   (unsigned char *)&snd_MusicVolume,sizeof(int),&ulRead);
	  IGameStream_USRead(pIStream,
	   (unsigned char *)&snd_Channels,sizeof(int),&ulRead);

	  IGameStream_Release(pIStream);
	  }

	 //
	 // Read the misc settings
	 hResult=IGameStorage_USOpenStream(pIStorage,
	  (unsigned char *)"Misc",USMODE_READWRITE,&pIStream);

	 if (SUCCEEDED(hResult))
	 {

	  IGameStream_USRead(pIStream,
	   (unsigned char *)&usejoystick,sizeof(usejoystick),&ulRead);
	  IGameStream_USRead(pIStream,
	   (unsigned char *)&joybfire,sizeof(joybfire),&ulRead);
	  IGameStream_USRead(pIStream,
	   (unsigned char *)&joybstrafe,sizeof(joybstrafe),&ulRead);
	  IGameStream_USRead(pIStream,
	   (unsigned char *)&joybuse,sizeof(joybuse),&ulRead);
	  IGameStream_USRead(pIStream,
	   (unsigned char *)&joybspeed,sizeof(joybspeed),&ulRead);
	  IGameStream_USRead(pIStream,
	   (unsigned char *)&screenblocks,sizeof(screenblocks),&ulRead);
	  IGameStream_USRead(pIStream,
	   (unsigned char *)&usegamma,sizeof(usegamma),&ulRead);

	  IGameStream_Release(pIStream);
	  }

	 //
	 // Detach and close down the storage
	 IGameStorage_Release(pIStorage);
	 IGame_Release(pIGame);
	 IPlayer_Release(pIPlayer);
	 IUniversalSave_Release(pIUS);
}

#endif	// USAVE